<ion-grid *ngIf="mode === 'update'" fixed class="ion-no-padding">
    <ion-row class="ion-justify-content-center">
        <ion-col size="auto">
            <div class="flex ion-justify-content-center height-132 width-150">
                <ion-avatar class="height-114 width-114">
                    <app-img
                        [src]="image.url"
                        [errorSrc]="defaultImage"
                        [alt]="user.nom"
                        title="Photo de profil docteur"
                        data-test-id="app-img"
                    ></app-img>
                </ion-avatar>
                <ion-avatar
                    data-test-icon="photoIcon"
                    (click)="openOptionSelection()"
                    (keyPress)="openOptionSelection()"
                    class="flex ion-align-items-center ion-justify-content-center"
                    *ngIf="!isReadOnly"
                >
                    <ion-icon name="camera-outline" color="dark"></ion-icon>
                </ion-avatar>
            </div>
        </ion-col>
    </ion-row>
</ion-grid>
<div
    class="info__fields border-1 border-solid has-border-primary has-background-white radius-30 ion-padding-vertical"
    [ngClass]="{ 'mx-20': mode === 'update', 'py-17 px-12': mode === 'create' }"
>
    <form
        *ngIf="registerForm"
        [formGroup]="registerForm"
        (ngSubmit)="onSubmit()"
    >
        <ion-grid class="px-12">
            <!-- Name -->
            <app-input-text
                [control]="registerForm"
                [name]="'name'"
                data-testid="lastname"
                [isReadonly]="isReadOnly"
                iconName="person-outline"
                inputType="text"
                placeholder="Nom"
                [errorMessages]="[
                    errors.required,
                    errors.noSpace,
                    errors.nameMin,
                    errors.nameMax
                ]"
                [validators]="nameValidator"
            >
            </app-input-text>
            <!-- FirstName -->
            <app-input-text
                [control]="registerForm"
                [name]="'firstName'"
                data-testid="firstname"
                [isReadonly]="isReadOnly"
                iconName="person-outline"
                inputType="text"
                placeholder="Prénom"
                [errorMessages]="[
                    errors.required,
                    errors.noSpace,
                    errors.nameMin,
                    errors.nameMax
                ]"
                [validators]="nameValidator"
            >
            </app-input-text>
            <!-- Phone -->
            <app-input-text
                [control]="registerForm"
                [name]="'phone'"
                data-testid="phone"
                [isReadonly]="isReadOnly"
                iconName="call-outline"
                inputType="tel"
                placeholder="Téléphone"
                [errorMessages]="[
                    errors.required,
                    errors.phoneMin,
                    errors.phoneMax,
                    errors.phone
                ]"
                [validators]="validators.phone"
            >
            </app-input-text>
            <!-- Email -->
            <app-input-text
                [control]="registerForm"
                [name]="'email'"
                data-testid="email"
                [isReadonly]="mode === 'update'"
                iconName="mail-outline"
                inputType="text"
                placeholder="Email"
                [errorMessages]="[errors.email]"
                [validators]="validators.email"
            >
            </app-input-text>
            <!-- Function -->
            <app-input-text
                [control]="registerForm"
                [name]="'function'"
                data-testid="fonction"
                [isReadonly]="isReadOnly"
                iconName="briefcase-outline"
                inputType="text"
                placeholder="Fonction"
                [errorMessages]="[errors.required, errors.noSpace]"
                [validators]="[
                    requiredValidator,
                    textValidator,
                    noSpaceValidators
                ]"
            >
            </app-input-text>
            <!-- Country -->
            <ion-row
                class="ion-align-items-center pl-9 ion-justify-content-center radius-30 border-1 border-solid"
                [ngClass]="
                    isReadOnly
                        ? 'has-border-grey'
                        : 'has-border-' + countryColor
                "
            >
                <ion-col size="auto" class="flex pr-0 py-0">
                    <ion-icon
                        name="earth-outline"
                        class="size-21"
                        [class]="'is-' + countryColor"
                    >
                    </ion-icon>
                </ion-col>
                <ion-col class="ion-no-padding" data-testid="country-field">
                    <div class="mr-16">
                        <app-ng-autocomplete
                            [data]="countries"
                            searchKeyword="name"
                            placeholder="Entrer votre pays"
                            [disabled]="isReadOnly"
                            [initialValue]="userCountry"
                            historyHeading="Récemment sélectionné"
                            (selected)="selectCountry($event)"
                            (inputCleared)="removeCountry()"
                            historyIdentifier="countries"
                            [itemTemplate]="itemTemplate"
                            [notFoundTemplate]="notFoundTemplate"
                            class="py-3 size-12"
                        >
                        </app-ng-autocomplete>

                        <ng-template #itemTemplate let-item>
                            <div class="m-10" data-testid="country-item">
                                <ion-text
                                    color="grey-fade"
                                    [innerHTML]="item.name"
                                >
                                </ion-text>
                            </div>
                        </ng-template>

                        <ng-template #notFoundTemplate let-notFound>
                            <ion-text color="grey-fade">Non trouvé</ion-text>
                        </ng-template>
                    </div>
                </ion-col>
            </ion-row>
            <!-- Required field -->
            <ion-text
                color="danger"
                *ngIf="
                    !registerForm.value.country &&
                    registerForm.controls.country.dirty
                "
                class="pl-5 size-12"
                data-test-id="error"
            >
                {{ requiredField.description }}
            </ion-text>

            <!-- Town -->
            <ion-row
                class="mt-10 ion-align-items-center pl-9 ion-justify-content-center radius-30 border-1 border-solid"
                [ngClass]="
                    isReadOnly
                        ? 'has-border-grey'
                        : 'has-border-' + countryColor
                "
            >
                <ion-col size="auto" class="flex pr-0 py-0">
                    <ion-icon
                        name="business-outline"
                        class="size-21"
                        [class]="'is-' + townColor"
                    >
                    </ion-icon>
                </ion-col>
                <ion-col class="ion-no-padding" data-testid="city-field">
                    <div class="mr-16">
                        <app-ng-autocomplete
                            [data]="cities"
                            searchKeyword="name"
                            placeholder="Entrer votre ville"
                            [initialValue]="userCity"
                            [disabled]="isReadOnly"
                            historyHeading="Récemment sélectionné"
                            (selected)="selectCity($event)"
                            (inputCleared)="removeCity()"
                            historyIdentifier="cities"
                            [itemTemplate]="cityTemplate"
                            [notFoundTemplate]="notFoundCityTemplate"
                            class="py-3 size-12"
                        >
                        </app-ng-autocomplete>

                        <ng-template #cityTemplate let-item>
                            <div class="m-10" data-testid="city-item">
                                <ion-text
                                    color="grey-fade"
                                    [innerHTML]="item.name"
                                ></ion-text>
                            </div>
                        </ng-template>

                        <ng-template #notFoundCityTemplate let-notFound>
                            <ion-text color="grey-fade">Non trouvé</ion-text>
                        </ng-template>
                    </div>
                </ion-col>
            </ion-row>
            <!-- Required field -->
            <ion-text
                color="danger"
                *ngIf="
                    !registerForm.value.town && registerForm.controls.town.dirty
                "
                class="pl-5 size-12"
                data-test-id="error"
            >
                {{ requiredField.description }}
            </ion-text>
        </ion-grid>
    </form>
</div>

<ion-row class="ion-justify-content-center mt-38 weight-500">
    <ion-col
        size="6"
        [ngClass]="{
            'is-white': !isReadOnly,
            'is-green': isReadOnly
        }"
    >
        <app-button
            *ngIf="mode === 'create'"
            [title]="'Inscription'"
            [loading]="loading"
            [icon]="'arrow-forward-outline'"
            fill="clear"
            [disabled]="!registerForm.valid"
            (click)="onSubmit()"
            (keyPress)="onSubmit()"
            shape="round"
            expand="full"
            color="primary"
            data-testid="signup"
            class="block border-solid border-1 has-border-spring-green radius-40"
        >
        </app-button>
        <app-button
            data-test-action="update"
            *ngIf="mode === 'update'"
            [title]="isReadOnly ? 'Modifier' : 'Valider'"
            [loading]="loading"
            [fill]="isReadOnly ? 'clear' : 'solid'"
            [disabled]="!registerForm.valid"
            (click)="onSubmit()"
            (keyPress)="onSubmit()"
            shape="round"
            expand="full"
            color="primary"
            class="mt-20"
            data-test-id="update-button"
            class="block border-solid border-1 has-border-primary radius-40"
        >
        </app-button>
    </ion-col>
</ion-row>
